import java.util.ArrayList;

public class Node
{
    String name;
    int index;
    double value;
    static final double high = 0.7;
    static final double low = 0.3;
    ArrayList<Device> devices;
    Node(String str) {
	name = str;
	value = 0.5;
	index = 0;
	devices = new ArrayList<Device>();
    }

    public String toString()
    {
	String str = name;
	for (Device d: devices) str += "\t" + d.name;
	return str;
    }
    public double getValue() { return value; }
    public void setValue(double v) { value = v; }
    public boolean isLow() { return value<low; }
    public boolean isHigh() { return value>high; }
    // returns true is value is neither low or high
    public boolean isUnknown()
    {
	if (isLow()) return false;
	return !isHigh();
    }
    public boolean equals(double v) { return (Math.abs(value-v)<1e-5); }
    public char getLogic()
    {
	if (isLow()) return '0';
	else if (isHigh()) return '1';
	else return 'X';
    }
}

    
    